                                                                                                                                                                                                                                               #include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels

#define OLED_RESET -1 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C // OLED I2C address for 128x32 display
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

#include <WiFi.h>
#include <HTTPClient.h>
#include <ArduinoJson.h>

const char* ssid = "iptime";
const char* password = "a123456789";
String url = "https://api.upbit.com/v1/ticker?markets=KRW-BTC";

void setup() {
  Serial.begin(115200);
  WiFi.begin(ssid, password);

  Serial.println("Connecting");
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("\nConnected to WiFi network with IP Address: ");
  Serial.println(WiFi.localIP());
  delay(5000);

  if (!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    Serial.println(F("SSD1306 allocation failed"));
    for (;;); // Stop if OLED allocation fails
  }

  display.clearDisplay();
}

void loop() {
  if (WiFi.status() == WL_CONNECTED) {
    HTTPClient http;
    http.begin(url);
    int httpCode = http.GET();

    if (httpCode == 200) {
      String response = http.getString();
      DynamicJsonDocument doc(1024);
      deserializeJson(doc, response);

      double tradePrice = doc[0]["trade_price"].as<double>();
      String tradeDate = doc[0]["trade_date_kst"];
      String tradeTime = doc[0]["trade_time_kst"];

      display.clearDisplay();
      display.setTextSize(1); // Set text size to fit all data on screen
      display.setTextColor(SSD1306_WHITE);
      display.setCursor(0, 0);
      display.println("BITCOIN");          // Coin name
      display.println("Date : " + tradeDate); // Date
      display.println("Time : " + tradeTime); // Time
      display.print("Price: ");
      display.println(tradePrice);           // Price
      display.display(); // Display all information on OLED

      Serial.println("코인명 : BITCOIN");
      Serial.println("날  짜 : " + tradeDate);
      Serial.println("시  간 : " + tradeTime);
      Serial.print("가  격 : ");
      Serial.println(tradePrice);

    } else {
      Serial.println("Error on HTTP request");
    }
    http.end();
  } else {
    Serial.println("WiFi not connected");
  }
  delay(1000); // Check price every 1 second
}
